﻿
Public Class Form1

    Private WithEvents mtimer As MilliTimer

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        EventsAreEnabled = False
        Text = AppTitleAndVersion("Theremino RGB")
        '
        Combo_InitFromEnum(cmb_Method, GetType(ChangeMethods))
        cmb_Method.SelectedIndex = 0
        '
        If CanUseWindowsDlls() Then
            MemoryMappedFile_Init()
        Else
            MemoryMappedFile_Init_Unix()
        End If
        InitRgbArray()
        Load_INI()
        SetChangeMethod()
        '
        mtimer = New MilliTimer()
        mtimer.Interval = txt_PollingTime.NumericValueInteger
        mtimer.Start()
        '
        Timer1.Interval = 10
        Timer1.Start()

        EventsAreEnabled = True
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        EventsAreEnabled = False
        Save_INI()
        If mtimer IsNot Nothing Then mtimer.Stop()
    End Sub

    Private Sub Form_LocationChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.LocationChanged
        If Not EventsAreEnabled Then Exit Sub
        LimitFormPosition(Me)
    End Sub

    Private Sub txt_PollingTime_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_PollingTime.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        mtimer.Interval = txt_PollingTime.NumericValueInteger
    End Sub


    '' ====================================================================================================
    ''  MilliTimerElapsed_ThreadSafe
    '' ====================================================================================================
    'Private Sub MilliTimerElapsed_ThreadSafe() Handles mtimer.MilliTimerElapsed
    '    Me.Invoke(New MilliTimerElapsed_Delegate(AddressOf MilliTimerElapsed))
    'End Sub
    'Private Delegate Sub MilliTimerElapsed_Delegate()
    'Private Sub MilliTimerElapsed()
    '    PollSlots()
    '    'TestTime()
    'End Sub

    ' ====================================================================================================
    '  MilliTimerElapsed_ThreadSafe - Without Delegate
    ' ====================================================================================================
    Private Sub MilliTimerElapsed_ThreadSafe() Handles mtimer.MilliTimerElapsed
        Me.Invoke(New Action(Of Int32)(AddressOf MilliTimerElapsed), 0)
    End Sub
    Private Sub MilliTimerElapsed(ByVal n As Int32)
        PollSlots()
        'TestTime()
    End Sub

    Private Sub TestTime()
        Static t As Double = 0
        t = t + mtimer.Interval
        If t >= 1000 Then
            t = 0
            'Beep()
            Me.Text = DateTime.Now.Millisecond.ToString
        End If
    End Sub

    Private Enum ChangeMethods As Int32
        EachSlotOneColor = 0
        FirstSlotOnly = 1
        Sinusoidal = 2
        Semi_sinusoidal = 3
        Triangular = 4
    End Enum
    Private ChangeMethod As ChangeMethods

    Friend Sub PollSlots()
        Select Case ChangeMethod
            Case ChangeMethods.EachSlotOneColor
                Dim slot As Int32 = txt_FirstInputSlot.NumericValueInteger
                If slot >= 0 Then
                    Dim tripPoint As Single = 500
                    Dim v As Single
                    For i As Int32 = 0 To txt_NumInputSlots.NumericValueInteger - 1
                        v = ReadSlot_NoNan(slot) : slot += 1
                        If v > tripPoint Then
                            PlayingNotes_Press(i)
                        Else
                            PlayingNotes_Release(i)
                        End If
                    Next
                End If
            Case ChangeMethods.FirstSlotOnly
                Dim slot As Int32 = txt_FirstInputSlot.NumericValueInteger
                If slot >= 0 Then
                    Dim n As Int32 = CInt(ReadSlot_NoNan(slot))
                    n = n Mod 128
                    SetNewColor(CInt(RgbArray(n).r), CInt(RgbArray(n).g), CInt(RgbArray(n).b))
                End If
            Case ChangeMethods.Sinusoidal, ChangeMethods.Semi_sinusoidal, ChangeMethods.Triangular
                AutoChanger()
        End Select
    End Sub

    ' ====================================================================================================
    '  RGB array
    ' ====================================================================================================
    Structure Color1000
        Dim r As Int32
        Dim g As Int32
        Dim b As Int32
    End Structure
    Private RgbArray(127) As Color1000

    Private Sub InitRgbArray()
        Dim c As Color
        For i As Int32 = 0 To 127
            Select Case i Mod 12
                Case 0 : c = Color.Red
                Case 1 : c = Color.RoyalBlue
                Case 2 : c = Color.Yellow
                Case 3 : c = Color.Fuchsia
                Case 4 : c = Color.DarkSeaGreen
                Case 5 : c = Color.Salmon
                Case 6 : c = Color.CadetBlue
                Case 7 : c = Color.Orange
                Case 8 : c = Color.PaleVioletRed
                Case 9 : c = Color.LimeGreen
                Case 10 : c = Color.Purple
                Case 11 : c = Color.CornflowerBlue
            End Select
            RgbArray(i).r = CInt(c.R * 3.91)
            RgbArray(i).g = CInt(c.G * 3.91)
            RgbArray(i).b = CInt(c.B * 3.91)
        Next
    End Sub

    Private Function ColorFromArgb1000(ByVal r As Single, ByVal g As Single, ByVal b As Single) As Color
        Return Color.FromArgb(CInt(r / 3.92), _
                              CInt(g / 3.92), _
                              CInt(b / 3.92))
    End Function


    ' ====================================================================================================
    '  Playing notes array
    ' ====================================================================================================
    Private PlayingNotes As Hashtable = New Hashtable
    Private Sub PlayingNotes_ReleaseAllNotes()
        For n As Int32 = 0 To 127
            PlayingNotes_Release(n)
        Next
    End Sub
    Private Sub PlayingNotes_Release(ByVal n As Int32)
        If PlayingNotes.Contains(n) Then
            PlayingNotes.Remove(n)
        End If
    End Sub
    Private Sub PlayingNotes_Press(ByVal n As Int32)
        If Not PlayingNotes.Contains(n) Then
            PlayingNotes.Add(n, 0)
            SetNewColor(CInt(RgbArray(n).r), CInt(RgbArray(n).g), CInt(RgbArray(n).b))
        End If
    End Sub


    ' ==============================================================================================================
    '   AUTO SAVE FOR ThereminoArm PARAMS - USING LostFocus
    ' ==============================================================================================================
    Private Sub ThereminoArmParams_LostFocus(ByVal sender As Object, ByVal e As System.EventArgs) _
                                                                            Handles cmb_Method.LostFocus, _
                                                                                    txt_PollingTime.LostFocus, _
                                                                                    txt_ChangeSpeed.LostFocus, _
                                                                                    txt_FirstInputSlot.LostFocus, _
                                                                                    txt_NumInputSlots.LostFocus, _
                                                                                    txt_FirstOutputSlot.LostFocus

        If Not EventsAreEnabled Then Return
        Save_INI()
    End Sub

    ' ====================================================================================================
    '  Combo Methods
    ' ====================================================================================================
    Private Sub Combo_DropDown(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_Method.DropDown
        CType(sender, ComboBox).ItemHeight = 16
    End Sub
    Private Sub Combo_DropDownClosed(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_Method.DropDownClosed
        CType(sender, ComboBox).ItemHeight = 12
    End Sub
    Private Sub Combo_Methods_SelectionChangeCommitted(ByVal sender As Object, ByVal e As System.EventArgs) _
                                                                    Handles cmb_Method.SelectionChangeCommitted
        If Not EventsAreEnabled Then Return
        SetChangeMethod()
    End Sub
    Private Sub SetChangeMethod()
        ChangeMethod = CType(cmb_Method.SelectedIndex, ChangeMethods)
    End Sub


    ' ==============================================================================================================
    '   TrackBars
    ' ==============================================================================================================
    Private Sub TrackBar0_LostFocus(ByVal sender As Object, ByVal e As System.EventArgs) _
                                                                            Handles TrackBar_Red.LostFocus, _
                                                                                    TrackBar_Green.LostFocus, _
                                                                                    TrackBar_Blue.LostFocus
        '
    End Sub
    Private Sub TrackBar_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) _
                                                                            Handles TrackBar_Red.Scroll, _
                                                                                    TrackBar_Green.Scroll, _
                                                                                    TrackBar_Blue.Scroll
        If Not EventsAreEnabled Then Return
        SetNewColor(TrackBar_Red.Value, TrackBar_Green.Value, TrackBar_Blue.Value)
        r = TrackBar_Red.Value
        g = TrackBar_Green.Value
        b = TrackBar_Blue.Value
    End Sub

    Private Sub SetNewColor(ByVal r As Int32, ByVal g As Int32, ByVal b As Int32)
        NewColor.r = r
        NewColor.g = g
        NewColor.b = b
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Dim speed As Single = CSng(txt_ChangeSpeed.NumericValue) / 100.0F
        r += (NewColor.r - r) * speed
        g += (NewColor.g - g) * speed
        b += (NewColor.b - b) * speed
        SendColorToOutput()
    End Sub

    Private NewColor As Color1000
    Private r As Single
    Private g As Single
    Private b As Single
    Private Sub SendColorToOutput()
        Dim c As Color = ColorFromArgb1000(r, g, b)
        Label_Color.BackColor = c
        ' ------------------------------------------------------------------- write to MMF
        Dim i As Int32 = txt_FirstOutputSlot.NumericValueInteger
        If i >= 0 Then
            If CanUseWindowsDlls() Then
                WriteSlot(i + 0, r)
                WriteSlot(i + 1, g)
                WriteSlot(i + 2, b)
            Else
                WriteSlot_Unix(i + 0, r)
                WriteSlot_Unix(i + 1, g)
                WriteSlot_Unix(i + 2, b)
            End If
        End If
        ' ----------------------------------------------------
        EventsAreEnabled = False
        TrackBar_Red.Value = CInt(r)
        TrackBar_Green.Value = CInt(g)
        TrackBar_Blue.Value = CInt(b)
        EventsAreEnabled = True
    End Sub


    ' ====================================================================================================
    '   Auto Changer
    ' ====================================================================================================
    Private Sub AutoChanger()
        Const kangle As Single = 2 * Math.PI / 1000.0F
        Static r, g, b As Single
        Dim speedr, speedg, speedb As Single
        Dim slot As Int32 = txt_FirstInputSlot.NumericValueInteger
        If slot > -1 Then
            speedr = ReadSlot_NoNan(slot) / 1000
            speedg = ReadSlot_NoNan(slot + 1) / 1000
            speedb = ReadSlot_NoNan(slot + 2) / 1000
        Else
            speedr = 1
            speedg = 1.3
            speedb = 1.7
        End If
        r = (r + speedr) Mod 1000
        g = (g + speedg) Mod 1000
        b = (b + speedb) Mod 1000
        Select Case ChangeMethod
            Case ChangeMethods.Sinusoidal
                SetNewColor_Sinusoidal(Math.Sin(r * kangle), Math.Sin(g * kangle), Math.Sin(b * kangle))
            Case ChangeMethods.Semi_sinusoidal
                SetNewColor_SemiSinusoidal(Math.Sin(r * kangle), Math.Sin(g * kangle), Math.Sin(b * kangle))
            Case ChangeMethods.Triangular
                SetNewColor_Triangular(r, g, b)
        End Select
    End Sub

    Private Sub SetNewColor_Sinusoidal(ByVal r As Double, ByVal g As Double, ByVal b As Double)
        NewColor.r = CInt(r * 500 + 500)
        NewColor.g = CInt(g * 500 + 500)
        NewColor.b = CInt(b * 500 + 500)
    End Sub

    Private Sub SetNewColor_SemiSinusoidal(ByVal r As Double, ByVal g As Double, ByVal b As Double)
        NewColor.r = CInt(Math.Abs(r) * 1000)
        NewColor.g = CInt(Math.Abs(g) * 1000)
        NewColor.b = CInt(Math.Abs(b) * 1000)
    End Sub

    Private Sub SetNewColor_Triangular(ByVal r As Double, ByVal g As Double, ByVal b As Double)
        If r >= 500 Then r = 1000 - r
        If g >= 500 Then g = 1000 - g
        If b >= 500 Then b = 1000 - b
        NewColor.r = CInt(r * 2)
        NewColor.g = CInt(g * 2)
        NewColor.b = CInt(b * 2)
    End Sub

End Class